// -*-C++-*-
/*!
 * @file  ManipulatorCommonInterface_CommonSVC_impl.cpp
 * @brief Service implementation code of ManipulatorCommonInterface_Common.idl
 *
 */

#include "ManipulatorCommonInterface_CommonSVC_impl.h"
#include "defreturnid.h"
#include "message.h"
#include <iostream>

/*
 * Example implementational code for IDL interface ManipulatorCommonInterface_Common
 */
ManipulatorCommonInterface_CommonSVC_impl::ManipulatorCommonInterface_CommonSVC_impl()
{
  // Please add extra constructor code here.
}


ManipulatorCommonInterface_CommonSVC_impl::~ManipulatorCommonInterface_CommonSVC_impl()
{
  // Please add extra destructor code here.
}

//O[oϐ
int iCommon;
double BufCommon[13];
double FileBufCommon[20];

//TimeStamp
SYSTEMTIME TimeStampCommon1,TimeStampCommon2;

//t@C|C^
FILE *fpCommon;

//֐ߍWn\tg~bgl
static double JUpper[5],JLower[5];


/*
 * Methods corresponding to IDL attributes and operations
 */
RETURN_ID* ManipulatorCommonInterface_CommonSVC_impl::clearAlarms()
{
	for(iCommon=0;iCommon<13;iCommon++){
		BufCommon[iCommon]=0.0;
	}

	BufCommon[0]=101;
	Message(BufCommon);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_CommonSVC_impl::getActiveAlarm(AlarmSeq_out alarms)
{
	//TimeStampCommon1̑
	GetLocalTime(&TimeStampCommon1);

	for(iCommon=0;iCommon<13;iCommon++){
		BufCommon[iCommon]=0.0;
	}

	BufCommon[0]=102;
	Message(BufCommon);
	
	//҂Ԃ
	Sleep(10);

	//t@CI[v
	fpCommon=fopen( "../../Info.dat", "r");
	//ǂݍ
	fscanf(fpCommon, "%lf,%lf,%lf,%lf,%lf,%lf", &FileBufCommon[0], &FileBufCommon[1], &FileBufCommon[2], &FileBufCommon[3], &FileBufCommon[4], &FileBufCommon[5]);//WʒuEp
	fscanf(fpCommon, "%lf,%lf", &FileBufCommon[6], &FileBufCommon[7]);//֐ߍWEObp
	fscanf(fpCommon, "%lf,%lf,%lf,%lf,%lf,%lf", &FileBufCommon[11], &FileBufCommon[12], &FileBufCommon[13], &FileBufCommon[14], &FileBufCommon[15], &FileBufCommon[16]);//G[
	fscanf(fpCommon, "%d,%d,%d,%d,%d,%d,%d", &TimeStampCommon2.wYear, &TimeStampCommon2.wMonth, &TimeStampCommon2.wDay, &TimeStampCommon2.wHour, &TimeStampCommon2.wMinute, &TimeStampCommon2.wSecond,&TimeStampCommon2.wMilliseconds);//TimeStamp
	//t@C
	fclose(fpCommon);

	//mFp
	std::cout<<FileBufCommon[0]<<" "<<FileBufCommon[1]<<" "<<FileBufCommon[2]<<" "<<FileBufCommon[3]<<" "<<FileBufCommon[4]<<" "<<FileBufCommon[5]<<std::endl<<FileBufCommon[6]<<" "<<FileBufCommon[7]<<" "<<FileBufCommon[8]<<" "<<FileBufCommon[9]<<" "<<FileBufCommon[10]<<std::endl<<FileBufCommon[11]<<" "<<FileBufCommon[12]<<" "<<FileBufCommon[13]<<" "<<FileBufCommon[14]<<" "<<FileBufCommon[15]<<" "<<FileBufCommon[16]<<std::endl<<TimeStampCommon2.wYear<<" "<<TimeStampCommon2.wMonth<<" "<<TimeStampCommon2.wDay<<" "<<TimeStampCommon2.wHour<<" "<<TimeStampCommon2.wMinute<<" "<<TimeStampCommon2.wSecond<<" "<<TimeStampCommon2.wMilliseconds<<std::endl;

	//TimeStamp̕]
	if(TimeStampCommon1.wYear==TimeStampCommon2.wYear){
		if(TimeStampCommon1.wMonth==TimeStampCommon2.wMonth){
			if(TimeStampCommon1.wDay==TimeStampCommon2.wDay){
				if(TimeStampCommon1.wHour==TimeStampCommon2.wHour){
					if(TimeStampCommon1.wMinute==TimeStampCommon2.wMinute){
						if(TimeStampCommon1.wSecond==TimeStampCommon2.wSecond){
							if(TimeStampCommon1.wMilliseconds==TimeStampCommon2.wMilliseconds){
								RETURNID_STATUS_ERR
									std::cout<<"Return Error"<<std::endl;
							}else if(TimeStampCommon1.wMilliseconds>TimeStampCommon2.wMilliseconds){
								RETURNID_STATUS_ERR
									std::cout<<"Return Error"<<std::endl;
							}
						}else if(TimeStampCommon1.wSecond>TimeStampCommon2.wSecond){
							RETURNID_STATUS_ERR
								std::cout<<"Return Error"<<std::endl;
						}
					}else if(TimeStampCommon1.wMinute>TimeStampCommon2.wMinute){
						RETURNID_STATUS_ERR
							std::cout<<"Return Error"<<std::endl;
					}
				}else if(TimeStampCommon1.wHour>TimeStampCommon2.wHour){
					RETURNID_STATUS_ERR
						std::cout<<"Return Error"<<std::endl;
				}
			}else if(TimeStampCommon1.wDay>TimeStampCommon2.wDay){
				RETURNID_STATUS_ERR
					std::cout<<"Return Error"<<std::endl;
			}
		}else if(TimeStampCommon1.wMonth>TimeStampCommon2.wMonth){
			RETURNID_STATUS_ERR
				std::cout<<"Return Error"<<std::endl;
		}
	}else if(TimeStampCommon1.wYear>TimeStampCommon2.wYear){
		RETURNID_STATUS_ERR
			std::cout<<"Return Error"<<std::endl;
	}
	


	//A[
	unsigned long AlarmNum = (unsigned long)FileBufCommon[11];
	alarms=new AlarmSeq;
	alarms->length(AlarmNum);

	if(FileBufCommon[13] != 0){
		(*alarms)[AlarmNum-1].code=0x00000004;
		(*alarms)[AlarmNum-1].type=AlarmType::FAULT;//ǂ?
		(*alarms)[AlarmNum-1].description="\tg~bgI[o(֐ߍW)";
		AlarmNum--;
	}
	if(FileBufCommon[14] != 0){
		(*alarms)[AlarmNum-1].code=0x00000005;
		(*alarms)[AlarmNum-1].type=AlarmType::FAULT;//ǂ?
		(*alarms)[AlarmNum-1].description="\tg~bgI[o(sW)";
		AlarmNum--;
	}
	if(FileBufCommon[15] != 0){
		(*alarms)[AlarmNum-1].code=0xFFFFFFFF;
		(*alarms)[AlarmNum-1].type=AlarmType::FAULT;
		(*alarms)[AlarmNum-1].description="Փˌm";
		AlarmNum--;
	}
	if(FileBufCommon[16] != 0){
		(*alarms)[AlarmNum-1].code=0xFFFFFFFF;
		(*alarms)[AlarmNum-1].type=AlarmType::FAULT;
		(*alarms)[AlarmNum-1].description="n[h~bgI[o";
		AlarmNum--;
	}

	std::cout<<"Return OK"<<std::endl;
	
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_CommonSVC_impl::getFeedbackPosJoint(JointPos_out pos)
{
	//TimeStampCommon1̑
	GetLocalTime(&TimeStampCommon1);

	for(iCommon=0;iCommon<13;iCommon++){
		BufCommon[iCommon]=0.0;
	}

	BufCommon[0]=103;
	Message(BufCommon);

	//҂Ԃ
	Sleep(10);

	//t@CI[v
	fpCommon=fopen( "../../Info.dat", "r");
	//ǂݍ
	fscanf(fpCommon, "%lf,%lf,%lf,%lf,%lf,%lf", &FileBufCommon[0], &FileBufCommon[1], &FileBufCommon[2], &FileBufCommon[3], &FileBufCommon[4], &FileBufCommon[5]);//WʒuEp
	fscanf(fpCommon, "%lf,%lf", &FileBufCommon[6], &FileBufCommon[7]);//֐ߍWEObp
	fscanf(fpCommon, "%lf,%lf,%lf,%lf,%lf,%lf", &FileBufCommon[11], &FileBufCommon[12], &FileBufCommon[13], &FileBufCommon[14], &FileBufCommon[15], &FileBufCommon[16]);//G[
	fscanf(fpCommon, "%d,%d,%d,%d,%d,%d,%d", &TimeStampCommon2.wYear, &TimeStampCommon2.wMonth, &TimeStampCommon2.wDay, &TimeStampCommon2.wHour, &TimeStampCommon2.wMinute, &TimeStampCommon2.wSecond,&TimeStampCommon2.wMilliseconds);//TimeStamp
	//t@C
	fclose(fpCommon);

	//TimeStamp̕]
	if(TimeStampCommon1.wYear==TimeStampCommon2.wYear){
		if(TimeStampCommon1.wMonth==TimeStampCommon2.wMonth){
			if(TimeStampCommon1.wDay==TimeStampCommon2.wDay){
				if(TimeStampCommon1.wHour==TimeStampCommon2.wHour){
					if(TimeStampCommon1.wMinute==TimeStampCommon2.wMinute){
						if(TimeStampCommon1.wSecond==TimeStampCommon2.wSecond){
							if(TimeStampCommon1.wMilliseconds==TimeStampCommon2.wMilliseconds){
								RETURNID_STATUS_ERR
							}else if(TimeStampCommon1.wMilliseconds>TimeStampCommon2.wMilliseconds){
								RETURNID_STATUS_ERR
							}
						}else if(TimeStampCommon1.wSecond>TimeStampCommon2.wSecond){
							RETURNID_STATUS_ERR
						}
					}else if(TimeStampCommon1.wMinute>TimeStampCommon2.wMinute){
						RETURNID_STATUS_ERR
					}
				}else if(TimeStampCommon1.wHour>TimeStampCommon2.wHour){
					RETURNID_STATUS_ERR
				}
			}else if(TimeStampCommon1.wDay>TimeStampCommon2.wDay){
				RETURNID_STATUS_ERR
			}
		}else if(TimeStampCommon1.wMonth>TimeStampCommon2.wMonth){
			RETURNID_STATUS_ERR
		}
	}else if(TimeStampCommon1.wYear>TimeStampCommon2.wYear){
		RETURNID_STATUS_ERR
	}

	pos=new JointPos;
	pos->length(1);

	for(iCommon=0;iCommon<1;iCommon++){
		(*pos)[iCommon]=FileBufCommon[iCommon+6];
	}

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_CommonSVC_impl::getManipInfo(ManipInfo_out mInfo)
{
	mInfo=new ManipInfo;
	mInfo->manufactur="YAMAHA";
	mInfo->type="T412BK-200";
	mInfo->axisNum=1;
	//mInfo->cmdCycle=7;
	//mInfo->isGripper=true;

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_CommonSVC_impl::getSoftLimitJoint(LimitSeq_out softLimit)
{
	//BufCommon[0]=105;
	//Message(BufCommon);
	//O[oϐǂݎ
	
	softLimit=new LimitSeq;
	softLimit->length(1);
	for(iCommon=0;iCommon<1;iCommon++){
		(*softLimit)[iCommon].upper=JUpper[iCommon];
		(*softLimit)[iCommon].lower=JLower[iCommon];
	}

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_CommonSVC_impl::getState(ULONG& state)
{
	//TimeStampCommon1̑
	GetLocalTime(&TimeStampCommon1);

	for(iCommon=0;iCommon<13;iCommon++){
		BufCommon[iCommon]=0.0;
	}

	BufCommon[0]=106;
	Message(BufCommon);

	//҂Ԃ
	Sleep(10);

	//t@CI[v
	fpCommon=fopen( "../../Info.dat", "r");
	//ǂݍ
	fscanf(fpCommon, "%lf,%lf,%lf,%lf,%lf,%lf", &FileBufCommon[0], &FileBufCommon[1], &FileBufCommon[2], &FileBufCommon[3], &FileBufCommon[4], &FileBufCommon[5]);//WʒuEp
	fscanf(fpCommon, "%lf,%lf", &FileBufCommon[6], &FileBufCommon[7]);//֐ߍWEObp
	fscanf(fpCommon, "%lf,%lf,%lf,%lf,%lf,%lf", &FileBufCommon[11], &FileBufCommon[12], &FileBufCommon[13], &FileBufCommon[14], &FileBufCommon[15], &FileBufCommon[16]);//G[
	fscanf(fpCommon, "%d,%d,%d,%d,%d,%d,%d", &TimeStampCommon2.wYear, &TimeStampCommon2.wMonth, &TimeStampCommon2.wDay, &TimeStampCommon2.wHour, &TimeStampCommon2.wMinute, &TimeStampCommon2.wSecond,&TimeStampCommon2.wMilliseconds);//TimeStamp
	//t@C
	fclose(fpCommon);

	//TimeStamp̕]
	if(TimeStampCommon1.wYear==TimeStampCommon2.wYear){
		if(TimeStampCommon1.wMonth==TimeStampCommon2.wMonth){
			if(TimeStampCommon1.wDay==TimeStampCommon2.wDay){
				if(TimeStampCommon1.wHour==TimeStampCommon2.wHour){
					if(TimeStampCommon1.wMinute==TimeStampCommon2.wMinute){
						if(TimeStampCommon1.wSecond==TimeStampCommon2.wSecond){
							if(TimeStampCommon1.wMilliseconds==TimeStampCommon2.wMilliseconds){
								RETURNID_STATUS_ERR
							}else if(TimeStampCommon1.wMilliseconds>TimeStampCommon2.wMilliseconds){
								RETURNID_STATUS_ERR
							}
						}else if(TimeStampCommon1.wSecond>TimeStampCommon2.wSecond){
							RETURNID_STATUS_ERR
						}
					}else if(TimeStampCommon1.wMinute>TimeStampCommon2.wMinute){
						RETURNID_STATUS_ERR
					}
				}else if(TimeStampCommon1.wHour>TimeStampCommon2.wHour){
					RETURNID_STATUS_ERR
				}
			}else if(TimeStampCommon1.wDay>TimeStampCommon2.wDay){
				RETURNID_STATUS_ERR
			}
		}else if(TimeStampCommon1.wMonth>TimeStampCommon2.wMonth){
			RETURNID_STATUS_ERR
		}
	}else if(TimeStampCommon1.wYear>TimeStampCommon2.wYear){
		RETURNID_STATUS_ERR
	}

	//
	
			m_state=0x00;
			/*
			if(){
				state|=0x01;
			}
			*/
			
			if((int)FileBufCommon[12] == 1){
				m_state|=0x02;
			}
			if((int)FileBufCommon[11] != 0){
				m_state|=0x04;
			}
			
			/*
			if(){
				state|=0x08;
			}
			if(){
				state|=0x10;
			}
			*/
			state=stateData();
	

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_CommonSVC_impl::servoOFF()
{
	for(iCommon=0;iCommon<13;iCommon++){
		BufCommon[iCommon]=0.0;
	}

	BufCommon[0]=107;
	Message(BufCommon);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_CommonSVC_impl::servoON()
{
	for(iCommon=0;iCommon<13;iCommon++){
		BufCommon[iCommon]=0.0;
	}

	BufCommon[0]=108;
	Message(BufCommon);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_CommonSVC_impl::setSoftLimitJoint(const LimitSeq& softLimit)
{

	for(iCommon=0;iCommon<13;iCommon++){
		BufCommon[iCommon]=0.0;
	}

	BufCommon[0]=109;
	//BufCommonɒl
	BufCommon[1]=softLimit[0].upper;
	BufCommon[2]=softLimit[0].lower;
	//100{đM
	for(iCommon=1;iCommon<3;iCommon++){
		BufCommon[iCommon]=BufCommon[iCommon]*100;
	}

	Message(BufCommon);

	//ϐ
	for(iCommon=0;iCommon<1;iCommon++){
		JUpper[iCommon]=softLimit[iCommon].upper;
		JLower[iCommon]=softLimit[iCommon].lower;
	}

	RETURNID_OK;
}



// End of example implementational code



