
//RobotSimulatorGUI_6Axes.h

#ifndef ROBOTSIMULATORGUI_6AXES_H
#define ROBOTSIMULATORGUI_6AXES_H

/*************************************define`********************************************************************************************************/
//}js[^EԒ
#define L0 350.0
#define L1 95.0
#define L2 245.0
#define L3 135.0
#define R3 60.0
#define L4 210.0
#define L5 85.0
#define L6 0.0//nh̒

//`ʃJp萔
#define VewLong 1500.0 //_王_܂ł̋[mm]
#define VewAngle 0.02618 //_ړ1vbV1.5[deg]

//}js[^E[Vp()
#define Cycle 0.01667 //\TCN[s]

/*************************************O[oϐ`************************************************************************************************/
//for[vpϐ
int i,j,k;

//`ʃJpϐ
double Vew1=-20.0/180.0*DX_PI,Vew2=30.0/180.0*DX_PI;//_px[rad]AEA㉺̏

//L[͏ԊĎp
char Buf[ 256 ] ;
int Cr;
int InputHandle ;

//tHgf[^p
int FontHandle ;

//TimeStampp
SYSTEMTIME TimeStamp;

//t@C|C^
FILE *fp;

//G[p
int AlarmError=0;//0:ʏ,1:T[{OFFԂł̓얽,2:֐ߊp\tg~bgl͈͊O,3:W\tg~bg͈͊O
static int Error1,Error2,Error3,Error4,Error5;

//ړ
double t;
//ԓ_
int iMax;
//݈ʒuڕW_܂ł̋
double Lts;

//fnh
int LOCAL0,LOCAL1,LOCAL2,LOCAL3,LOCAL4,LOCAL5,LOCAL6,HANDBASE;

//}js[^ʒu
VECTOR J[8];//e֐ߌݒl[֐ߔԍ(1`6) or Hand(7)].(x,y,z)
VECTOR rt;//ڕWl.(x,y,z)**΍W
VECTOR rw;//ڕWW.(x,y,z)**J2W
VECTOR rs;//惂[VX^[gl.(x,y,z)

static VECTOR track[200];

VECTOR rc,r1,rBuf;//~ʕԂ̒S_EoR_E
VECTOR n;//@xNg
static double a1,b1,c1,d1,a2,b2,c2,d2,a3,b3,c3,d3;//ʂ̌̕W:ax+by+cz+d=0,sx+ty+uz+v=0,mx+ny+oz+p=0
static double CAngle,CAngleMax;
static double CAngles1,CAngle1t,CAnglets;

//}js[^p
double JAngle[7];//e֐ߌ݊px[֐ߔԍ(1`6)]
double JAnglet[7];//e֐ߖڕWpx[֐ߔԍ(1`6)](pɉ肵ꍇ̊px\)
double OriginalJAngle[7];//{bg{̂̏pɍ킹֐ߊpx\
double JAngles[7];//e֐߃[VX^[gpx[֐ߔԍ(1`6)]
double EulerAngle[3];//ڕWIC[p[,,]
VECTOR VEt[3];//ڕWps[x,y,z]
VECTOR VE[7][3];//ps[֐ߔԍ(1`6)][x,y,z]

//4p
double TAngle;//ڕWp(Z]l)[rad]
double TAnglew;//ڕWpu(Z]l)[rad]
double TAngles;//p[VX^[gl(Z]l)[rad]
double JAngleO[7];//_Åe֐ߊpx[rad]

//nh
double Hand=100.0;//݂̊J[%]
double Hands=Hand;//[VX^[g̊J[%]
double Handt;//ڕWJ[%]

//f`ʗpϊs
MATRIX MT01,MT02,MT03,MT04,MT04p,MT05,MT05p,MT06,MT07,MT0G;
MATRIX MT0HandL,MT0HandR;
MATRIX MT;

//ϊs
double T01[4][4],T02[4][4],T03[4][4],T04p[4][4],T04[4][4],T05[4][4],T05p[4][4],T06[4][4],T07[4][4];//(W0猩W)[c][]
double T12[4][4],T23[4][4],T34[4][4],T44p[4][4],T4p5[4][4],T55p[4][4],T5p6[4][4],T67[4][4];//(i-1W猩W)[c][]
double T0Hand[4][4],T0HandL[4][4],T0HandR[4][4];
double T6Hand[4][4],T6HandL[4][4],T6HandR[4][4];
//ꎲxNg
VECTOR J0,J1,J2,J3,J4,J5,J6,J7;

/*************************************eݒl(set֐ɂ)***************************************************************************************/
//T[{ON/OFF(1/0)
BOOL Servo;

//Wñ\tg~bgl[mm]
double CUpperLimit[3];
double CLowerLimit[3];

//֐ߍWñ\tg~bgl[rad]//Obp܂
double JUpperLimit[7];
double JLowerLimit[7];

//𓮍쎞̉[s]
double CAccelTime;

//֐ߓ쎞̉[s]
double JAccelTime;

//𓮍쎞̍ő哮쑬x
double CMaxSpeedTran;//[mm/s]
double CMaxSpeedRot;//[rad/s]

//֐ߓ쎞̍ő哮쑬x[rad/s]
double JMaxSpeed[7];

//𓮍쎞̍ŏ[s]
double CMinAccelTime;

//֐ߓ쎞̍ŏ[s]
double JMinAccelTime;

//𓮍쎞̑x[%]
double CSpeedRate;

//֐ߓ쎞̑x[%]
double JSpeedRate;

//bZ[WM
char ClassName[] = "RV_3SD";//NX
WNDCLASSEX wcex;
HWND hWnd;
MSG msg;
double MessageBuf[20];//obt@[

/*************************************֐vg^Cv錾**********************************************************************************************/
//bZ[WM֐
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
//ݒ֐
void SetUp();
//Ns̊|Zs֐
void SquareMatrix(double a[4][4],double b[4][4],double c[4][4]);
//NsNxNg̊|Zs֐
void MatrixVector(double a[4][4],double b[4],double c[4]);
//ϊsvZ֐
void HomogeneousTransformation(double T[4][4] , double Angle_a , double Angle_b , double A , double D );
//`֐
void DrawAll();
//^w֐
void ForwardKinematics();
//t^w֐
void InverseKinematics();
//psvZ֐(Eulerp)
void PoseMatrix();
//PTPԊ֐
void MovePTP();
//Ԋ֐
void MoveLiner();
//~ʕԊ֐
void MoveCircular();
//nhJ֐
void HandOpenClose();
//֐ߊp\tg~bgf֐
void JLimitJudge();
//W\tg~bgf֐
void CLimitJudge();


/*************************************֐vg^Cv錾(Iy[V)(ʃR}h)**************************************************************/
//No. 1 A[NA
void Mode101();
//No. 2 A[擾*
void Mode102();
//No. 3 ֐ߍWn̈ʒutB[hobN̎擾*
void Mode103();
//No. 6 jbg̏Ԏ擾*
void Mode106();
//No. 7 ST[{OFF
void Mode107();
//No. 8 ST[{ON
void Mode108();
//No. 9 ֐ߍWñ\tg~bglݒ
//		mn(LimitJAngleMax[1`6],LimitJAngleMin[1`6])ẽ\tg~bgl[deg] (E)
void Mode109();

/*************************************֐vg^Cv錾(Iy[V)(x[VR}h)************************************************/
//No. 1 Obp
void Mode201();
//No. 3 Wn̈ʒutB[hobN̎擾*
void Mode203();
//No. 9 Obp̊J
//		mn(GripperOpenRatio)Obp̊Jpx[%]
void Mode209();
//No. 10 W̒(Ύw)
//		mn(rt[x,y,z],EulerAngle[A,B,C])ΖڕWʒuEp[mm,deg]
void Mode210();
//No. 11 W̒(Ύw)
//		mn(rt[x,y,z],EulerAngle[A,B,C])ΖڕWʒuEp[mm,deg]
void Mode211();
//No. 12 ֐ߍW̒(EΎw)
//		mn(rt[x,y,z],EulerAngle[A,B,C])ΖڕWʒuEp[mm,deg]
void Mode212();
//No. 13 ֐ߍW̒(EΎw)
//		mn(rt[x,y,z],EulerAngle[A,B,C])ΖڕWʒuEp[mm,deg]
void Mode213();
//No. 14 ֐ߍW̒(֐߁EΎw)
//		mn(JAnglet[1`6])ΖڕWʒu[deg]
void Mode214();
//No. 15 ֐ߍW̒(֐߁EΎw)
//		mn(JAnglet[1`6])ΖڕWʒu[deg]
void Mode215();
//No. 16 ObpJ
void Mode216();
//No. 20 𓮍쎞̉Ԃݒ
//		mn(CAccelTime)[s]
void Mode220();
//No. 21 ֐ߓ쎞̉Ԃݒ
//		mn(JAccelTime)[s]
void Mode221();
//No. 22 }js[^̐ݒuʒuݒ
//		mn(BaseOffsetPosition[x,y,z],BaseOffsetPose[A,B,C])ItZbgʈʒuEp[mm,deg]
void Mode222();
//No. 23 _̃tWʂ̃ItZbgʂݒ
//		mn(FrangeOffsetPosition[x,y,z],FrangeOffsetPose[A,B,C])ItZbgʈʒuEp[mm,deg]
void Mode223();
//No. 24 𓮍쎞̍ő哮쑬xݒ
//		mn(CVelocityMax)őix [mm/s],(CartesianRevolutionMax)ő]x[deg/s]
void Mode224();
//No. 25 ֐ߓ쎞̍ő哮쑬xݒ
//		mn(JVelocityMax)e̍ő哮쑬x[deg/s]
void Mode225();
//No. 26 𓮍쎞̍ŏԂݒ
//		mn(CAccelTimeMin)ŏ[s]
void Mode226();
//No. 27 ֐ߓ쎞̍ŏԂݒ
//		mn(JAccelTimeMin)ŏ[s]
void Mode227();
//No. 28 Wñ\tg~bglݒ
//		mn(LimitCPositionMax[x,y,z],LimitCPositionMin[x,y,z])ẽ\tg~bgl[mm](E)
void Mode228();
//No. 29 𓮍쎞̑xݒ
//		mn(CVelocityRaito)ő呬xɑ΂銄w[%]
void Mode229();
//No. 30 ֐ߓ쎞̑xݒ
//		mn(JVelocityRaito)ő呬xɑ΂銄w[%]
void Mode230();



/*************************************֐vg^Cv錾(Iy[V)(x[VR}hEǉR}h)**********************************/
//No. 31 W̉~ʕ(Ύw)
//		mn(rt1[x,y,z],EulerAngle1[A,B,C],rt2[x,y,z],EulerAngle2[A,B,C])ΖڕWʒuEp[mm,deg]
void Mode231();
//No. 32 W̉~ʕ(Ύw)
//		mn(rt1[x,y,z],EulerAngle1[A,B,C],rt2[x,y,z],EulerAngle2[A,B,C])ΖڕWʒuEp[mm,deg]
void Mode232();
//No. 33 _ÄʒuEpݒ
//		mn(rt[x,y,z],EulerAngle[A,B,C])ΖڕWʒuEp[mm,deg]
void Mode233();
//No. 34 _ÄʒuEp擾*
void Mode234();
//No. 35 _A
void Mode235();

#endif
