//RobotSimulatorGUI_1Axis.h

#ifndef ROBOTSIMULATORGUI_1AXIS_H
#define ROBOTSIMULATORGUI_1AXIS_H

/*************************************define`********************************************************************************************************/
//}js[^EԒ
#define H0 35.0
#define H1 10.0
#define H2 0.0//nh̒
#define L1 0.0

//`ʃJp萔
#define VewLong 650.0 //_王_܂ł̋[mm]
#define VewAngle 0.02618 //_ړ1vbV1.5[deg]

//}js[^E[Vp()
#define Cycle 0.01667 //\TCN[s]

/*************************************O[oϐ`************************************************************************************************/
//for[vpϐ
int i,j,k;

//`ʃJpϐ
double Vew1=-40.0/180.0*DX_PI,Vew2=0.5233;//_px[rad]AEA㉺̏

//L[͏ԊĎp
char Buf[ 256 ] ;
int Cr;
int InputHandle ;

//tHgf[^p
int FontHandle ;

//TimeStampp
SYSTEMTIME TimeStamp;

//t@C|C^
FILE *fp;

//G[p
int AlarmError=0;//0:ʏ,1:T[{OFFԂł̓얽,2:֐ߊp\tg~bgl͈͊O,3:W\tg~bg͈͊O
static int Error1,Error2,Error3,Error4,Error5;

//ړ
double t;
//ԓ_
int iMax;
//݈ʒuڕW_܂ł̋
double Lts;

//fnh
int LOCAL0,LOCAL1;

//}js[^ʒu
VECTOR J[3];//e֐ߓ_ݒl[֐ߔԍ(1) or Hand(2)].(x,y,z)
VECTOR rt;//ڕWl.(x,y,z)**΍W
VECTOR rw;//ڕWW.(x,y,z)**J2W
VECTOR rs;//惂[VX^[gl.(x,y,z)

//}js[^p
double JAngle[2];//֐߈ʒu[mm]
double JAngles[2];//֐߃[VX^[gʒu[mm]
double JAnglet[2];//֐ߖڕWʒu[mm]
double JAngleO[2];//_Å֐߈ʒu[mm]

//nh
double Hand=100.0;//݂̊J[%]
double Hands=Hand;//[VX^[g̊J[%]
double Handt;//ڕWJ[%]

//f`ʗpϊs
MATRIX MT01,MT02,MT0Hand,MT0G;
MATRIX MT12,MT2Hand,MTG1;
MATRIX MT0HandL,MT0HandR;

/*************************************eݒl(set֐ɂ)***************************************************************************************/
//T[{ON/OFF(1/0)
BOOL Servo;

//Wñ\tg~bgl[mm]
double CUpperLimit[3];
double CLowerLimit[3];

//֐ߍWñ\tg~bgl[rad]//Obp܂
double JUpperLimit[5];
double JLowerLimit[5];

//𓮍쎞̉[s]
double CAccelTime;

//֐ߓ쎞̉[s]
double JAccelTime;

//𓮍쎞̍ő哮쑬x
double CMaxSpeedTran;//[mm/s]
double CMaxSpeedRot;//[rad/s]

//֐ߓ쎞̍ő哮쑬x[rad/s]
double JMaxSpeed[7];

//𓮍쎞̍ŏ[s]
double CMinAccelTime;

//֐ߓ쎞̍ŏ[s]
double JMinAccelTime;

//𓮍쎞̑x[%]***{͏l0%
double CSpeedRate;

//֐ߓ쎞̑x[%]***{͏l0%
double JSpeedRate;

//bZ[WM
char ClassName[] = "T412BK_200";//NX
WNDCLASSEX wcex;
HWND hWnd;
MSG msg;
double MessageBuf[20];//obt@[

/*************************************֐vg^Cv錾**********************************************************************************************/
//bZ[WM֐
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
//ݒ֐
void SetUp();
//`֐
void DrawAll();
//^w֐
void ForwardKinematics();
//t^w֐
void InverseKinematics();
//psvZ֐(Z->Y->X)
//void PoseMatrix();
//PTPԊ֐
void MovePTP();
//Ԋ֐
void MoveLiner();
//~ʕԊ֐
void MoveCircular();
//nhJ֐
void HandOpenClose();
//֐ߊp\tg~bgf֐
void JLimitJudge();
//W\tg~bgf֐
void CLimitJudge();

/*************************************֐vg^Cv錾(Iy[V)(ʃR}h)**************************************************************/
//No. 1 A[NA
void Mode101();
//No. 2 A[擾*
void Mode102();
//No. 3 ֐ߍWn̈ʒutB[hobN̎擾*
void Mode103();
//No. 6 jbg̏Ԏ擾*
void Mode106();
//No. 7 ST[{OFF
void Mode107();
//No. 8 ST[{ON
void Mode108();
//No. 9 ֐ߍWñ\tg~bglݒ
//		mn(LimitJAngleMax[1`6],LimitJAngleMin[1`6])ẽ\tg~bgl[deg] (E)
void Mode109();

/*************************************֐vg^Cv錾(Iy[V)(x[VR}h)************************************************/
//No. 1 Obp
void Mode201();
//No. 3 Wn̈ʒutB[hobN̎擾*
void Mode203();
//No. 9 Obp̊J
//		mn(GripperOpenRatio)Obp̊Jpx[%]
void Mode209();
//No. 14 ֐ߍW̒(֐߁EΎw)
//		mn(JAnglet[1`6])ΖڕWʒu[deg]
void Mode214();
//No. 15 ֐ߍW̒(֐߁EΎw)
//		mn(JAnglet[1`6])ΖڕWʒu[deg]
void Mode215();
//No. 16 ObpJ
void Mode216();
//No. 20 𓮍쎞̉Ԃݒ
//		mn(CAccelTime)[s]
void Mode220();
//No. 21 ֐ߓ쎞̉Ԃݒ
//		mn(JAccelTime)[s]
void Mode221();
//No. 22 }js[^̐ݒuʒuݒ
//		mn(BaseOffsetPosition[x,y,z],BaseOffsetPose[A,B,C])ItZbgʈʒuEp[mm,deg]
void Mode222();
//No. 23 _̃tWʂ̃ItZbgʂݒ
//		mn(FrangeOffsetPosition[x,y,z],FrangeOffsetPose[A,B,C])ItZbgʈʒuEp[mm,deg]
void Mode223();
//No. 24 𓮍쎞̍ő哮쑬xݒ
//		mn(CVelocityMax)őix [mm/s],(CartesianRevolutionMax)ő]x[deg/s]
void Mode224();
//No. 25 ֐ߓ쎞̍ő哮쑬xݒ
//		mn(JVelocityMax)e̍ő哮쑬x[deg/s]
void Mode225();
//No. 26 𓮍쎞̍ŏԂݒ
//		mn(CAccelTimeMin)ŏ[s]
void Mode226();
//No. 27 ֐ߓ쎞̍ŏԂݒ
//		mn(JAccelTimeMin)ŏ[s]
void Mode227();
//No. 28 Wñ\tg~bglݒ
//		mn(LimitCPositionMax[x,y,z],LimitCPositionMin[x,y,z])ẽ\tg~bgl[mm](E)
void Mode228();
//No. 29 𓮍쎞̑xݒ
//		mn(CVelocityRaito)ő呬xɑ΂銄w[%]
void Mode229();
//No. 30 ֐ߓ쎞̑xݒ
//		mn(JVelocityRaito)ő呬xɑ΂銄w[%]
void Mode230();



/*************************************֐vg^Cv錾(Iy[V)(x[VR}hEǉR}h)**********************************/
//No. 33 _ÄʒuEp擾*
void Mode233();
//No. 35 _A
void Mode235();

#endif
